This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 199246

Summary: [enh] support bridges
Product: [Fedora] Fedora Reporter: Evandro Gardenali <evandro.gardenali>
Component: NetworkManagerAssignee: Dan Williams <dcbw>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: 18CC: alonbl, bill-bugzilla.redhat.com, bjrosen, dcbw, ehabkost, ericsbinaryworld, fdeutsch, fedora, fschwarz, gczarcinski, gilboad, james.brown, jamundso, johnny.westerlund, kronos, martin, netllama, nexion.hellborn, rob, rob.townley, sgordon, tomek, triage
Target Milestone: ---Keywords: Triaged
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: bzcl34nup
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-02-05 17:37:56 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 807039    
Attachments:
Description Flags
ifmodeswitcher none

Description Evandro Gardenali 2006-07-18 08:45:22 EDT
Description of problem:

system-config-network lacks way to do bridging, a very common thing that should
be supported
Comment 1 Juliano F. Ravasi 2007-04-24 17:07:54 EDT
Just to note that Fedora supports bridging. Just system-config-network that
doesn't. To make a bridge:

1. service network stop
2. Create a /etc/sysconfig/networking/devices/ifcfg-br0 like any other device,
but with TYPE=Bridge;
3. ln /etc/sysconfig/networking/devices/ifcfg-br0
/etc/sysconfig/networking/profiles/default/ifcfg-br0
4. ln /etc/sysconfig/networking/devices/ifcfg-br0
/etc/sysconfig/network-scripts/ifcfg-br0
5. Edit ifcfg-* files for other interfaces that will participate on the bridge,
take out all address information (IPADDR, NETMASK, etc) and add BRIDGE=br0.
6. service network start

The bridge is shown in system-config-network, but you cant edit it.
Comment 2 Bug Zapper 2008-04-03 13:48:16 EDT
Based on the date this bug was created, it appears to have been reported
against rawhide during the development of a Fedora release that is no
longer maintained. In order to refocus our efforts as a project we are
flagging all of the open bugs for releases which are no longer
maintained. If this bug remains in NEEDINFO thirty (30) days from now,
we will automatically close it.

If you can reproduce this bug in a maintained Fedora version (7, 8, or
rawhide), please change this bug to the respective version and change
the status to ASSIGNED. (If you're unable to change the bug's version
or status, add a comment to the bug and someone will change it for you.)

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we're following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.
Comment 3 Juliano F. Ravasi 2008-05-03 07:34:53 EDT
Still an issue in current rawhide.
Comment 4 John Poelstra 2008-05-05 19:24:44 EDT
thanks for your update
Comment 5 Bug Zapper 2008-05-13 22:14:04 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Jerry Amundson 2008-12-11 17:32:11 EST
(In reply to comment #1)
> Just to note that Fedora supports bridging. Just system-config-network that
> doesn't. To make a bridge:
> 
> 1. service network stop
> 2. Create a /etc/sysconfig/networking/devices/ifcfg-br0 like any other device,
> but with TYPE=Bridge;
> 3. ln /etc/sysconfig/networking/devices/ifcfg-br0
> /etc/sysconfig/networking/profiles/default/ifcfg-br0
> 4. ln /etc/sysconfig/networking/devices/ifcfg-br0
> /etc/sysconfig/network-scripts/ifcfg-br0
> 5. Edit ifcfg-* files for other interfaces that will participate on the bridge,
> take out all address information (IPADDR, NETMASK, etc) and add BRIDGE=br0.
> 6. service network start
> 
> The bridge is shown in system-config-network, but you cant edit it.

And if you try to edit it, a traceback occurs.
(Fedora 10, system-config-network-1.5.94-2.fc10.noarch)
Component: system-config-network
Version: 1.5.94
Summary: TBf8f4a16f NCDevice.py:177:getDialog:TypeError: exceptions must be classes, instances, or strings (deprecated), not NotImplementedType

Traceback (most recent call last):
  File "/usr/share/system-config-network/netconfpkg/gui/maindialog.py", line 814, in on_editButton_clicked
    self.editButtonFunc[self.active_page](button)
  File "/usr/share/system-config-network/netconfpkg/gui/maindialog.py", line 922, in on_deviceEditButton_clicked
    button = self.editDevice(device)
  File "/usr/share/system-config-network/netconfpkg/gui/maindialog.py", line 950, in editDevice
    dialog = device.getDialog()
  File "/usr/share/system-config-network/netconfpkg/NCDevice.py", line 177, in getDialog
    raise NotImplemented
TypeError: exceptions must be classes, instances, or strings (deprecated), not NotImplementedType

Local variables in innermost frame:
self: Device.AllowUser=False
Device.BootProto=dhcp
Device.Device=br0
Device.DeviceId=br0
Device.HardwareAddress=00:1e:4f:c1:e6:b2
Device.Hostname=jerry-opti755
Device.IPv6Init=False
Device.NMControlled=False
Device.OnBoot=False
Device.Type=Bridge
Comment 7 Harald Hoyer 2008-12-12 02:10:41 EST
should be 

raise NotImplementedError
Comment 8 Jerry Amundson 2008-12-12 10:45:23 EST
(In reply to comment #7)
> should be 
> 
> raise NotImplementedError

Which then just changes the names in the traceback:
Component: system-config-network                                                
Version: 1.5.94                                                                 
Summary: TBf8f4a16f NCDevice.py:177:getDialog:NotImplementedError               

Traceback (most recent call last):
  File "/usr/share/system-config-network/netconfpkg/gui/maindialog.py", line 814, in on_editButton_clicked                                                      
    self.editButtonFunc[self.active_page](button)                               
  File "/usr/share/system-config-network/netconfpkg/gui/maindialog.py", line 922, in on_deviceEditButton_clicked
    button = self.editDevice(device)
  File "/usr/share/system-config-network/netconfpkg/gui/maindialog.py", line 950, in editDevice
    dialog = device.getDialog()
  File "/usr/share/system-config-network/netconfpkg/NCDevice.py", line 177, in getDialog
    raise NotImplementedError
NotImplementedError

Local variables in innermost frame:
self: Device.AllowUser=False
Device.BootProto=dhcp
Device.Device=br0
Device.DeviceId=br0
Device.HardwareAddress=00:1e:4f:c1:e6:b2
Device.Hostname=jerry-opti755
Device.IPv6Init=False
Device.NMControlled=False
Device.OnBoot=False
Device.Type=Bridge
Comment 9 Bug Zapper 2009-06-09 18:13:34 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Bug Zapper 2009-11-16 02:51:48 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Jiri Popelka 2010-02-08 04:46:50 EST
*** Bug 562608 has been marked as a duplicate of this bug. ***
Comment 12 Joshua Rosen 2010-02-08 08:12:27 EST
Adding bridge support to system-config-network should be pretty trivial how come no one has bothered to do it in the four years since the initial request was made?

Bridging is more important now that KVM is mainstream. KVM requires a bridge device if you want a VM to be visable on your network. When this request was originally posted the main virtualization option was VMware which handled the bridging problem itself so it wasn't as important that the network GUI do the job, but now that KVM is becoming the virtualizer of choice it would be nice if bridges were handled like any other network device.
Comment 13 Joshua Rosen 2010-02-08 08:50:54 EST
A suggestion for handling the UI. Just add an Enable Bridging button to the General Device Dialog. Enabling the option would put the line,

BRIDGE=br#

Into the ifcfg-eth# script and create the ifcfg-br# script which would get it's parameters from the same device dialog, for example,

DEVICE=br0
TYPE=Bridge
BOOTPROTO=none
DNS1=192.168.1.1
GATEWAY=192.168.1.1
IPADDR=192.168.1.6
NETMASK=255.255.255.0
ONBOOT=yes
NM_CONTROLLED=no
IPV6INIT=no
USERCTL=no
Comment 14 Harald Hoyer 2010-02-09 04:43:41 EST
Moving to NetworkManager, the one tool to rule it all
Comment 15 Dan Williams 2010-10-07 00:30:45 EDT
*** Bug 558982 has been marked as a duplicate of this bug. ***
Comment 16 Dan Williams 2010-10-07 00:32:14 EDT
*** Bug 639522 has been marked as a duplicate of this bug. ***
Comment 17 Andrew Luecke 2010-10-23 02:58:50 EDT
This is still a problem in Fedora 14 beta. I need it to quickly transfer all of my data to my NAS device (it's normally connected by wireless), without messing with the configuration. 

Windows has allowed bridging to be easy since at least Windows XP.
Comment 18 johnny.westerlund 2011-02-16 04:27:04 EST
Is there some way to sponsor this work? I am not a coder myself but i would be happy to donate $$ for this feature. I myself use a laptop and having bridge support in NetworkManager would be awsome.
Comment 19 Andrew Luecke 2011-02-16 04:51:03 EST
I'd be happy to sponsor it a bit too.. 

There are only a few major annoyances left in Fedora, and this is one of them. It couldn't be too hard considering even mobiles these days act as Mobile AP's.
Comment 20 Stephen Gordon 2011-06-01 01:27:24 EDT
Still a problem in F15 and becoming more annoying as more programs use NetworkManager to determine if network connectivity is available or not (empathy and the yum update applet on a default F15 installation for example) and therefore refuse to make use of a manually created bridge without further configuration changes.
Comment 21 Kronos003 2011-07-13 04:52:50 EDT
I agree. It would be very nice if i could have bridging without the need for disabling "NetworkManager" and enabling "network". I use bridging for my KVM virtual machines on my laptop, but i also need be able to connect to wireless as well when im not using bridging. here's a script i use to automate the transition from NetworkManager to "bridging mode"

#!/usr/bin/sh
virsh net-destroy default
service NetworkManager stop
chkconfig NetworkManager off
service network restart
virsh net-start default


NOTES: as of this moment i havent yet tested if chkconfig is "session only" or "until you change it back"

Honestly, this has been a problem for several years. Why has noone built this into network manager yet? As a previous poster stated, more and more programs are starting to depend on NetworkManager to get the link state. if NM cant cope with bridging, this problem is going to become increasingly severe.


I too might be willing to sponsor this (Especially if network manager and make bridging possible for wireless networks as well(by whatever means necessary))
Comment 22 Gene Czarcinski 2011-07-15 13:34:04 EDT
I have changed the release to Fedora 15 since it still appears to be a "problem".

This report seems to have been originally opened against system-config-network but is now against NetworkManager since that is the currenet direction for network configuration, etc.

Obviously, there must be some significant problem supporting bridging with NetworkManager or (with all of the griping) it would have been done.

Is there any hope or is this one of those "you can't get there from here" sort of problems?

Is this better taken up on the mailing list or here in bugzilla?
Comment 23 Kronos003 2011-07-16 13:40:26 EDT
Created attachment 513492 [details]
ifmodeswitcher

Here is a quick script i wrote to switch between bridge mode and normal mode for those of us who need to be able to use the features of wifi and bridging in the same machine, on the same session even. be advised that you cant do both at the same time with this script...
Comment 24 Stephen Gordon 2011-11-18 10:13:05 EST
Moving it up to 16 because what do you know, Network Manager still doesn't support bridging.
Comment 25 Bill McGonigle 2012-05-29 16:07:37 EDT
I saw in the F17 features list that the plumbing for this is now in place.  The GUI is due in F18 at the moment.
Comment 26 Eric Mesa 2012-06-05 14:25:06 EDT
(In reply to comment #25)
> I saw in the F17 features list that the plumbing for this is now in place. 
> The GUI is due in F18 at the moment.

AWESOME!  I love virt-manager way more than VirtualBox or VMWare, but it's pretty useless to me until bridging is implemented.  I really, really hope it gets put into F18.  Too bad it's going to be another 6 months until we have that....
Comment 27 Fedora End Of Life 2013-01-16 19:55:58 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 28 Gene Czarcinski 2013-01-17 12:15:13 EST
Changed release.  Although there is development progress, this functionality is still not available.
Comment 29 Dan Williams 2013-02-04 12:52:23 EST
(In reply to comment #28)
> Changed release.  Although there is development progress, this functionality
> is still not available.

About to land in Fedora soon.
Comment 30 Gene Czarcinski 2013-02-04 13:24:54 EST
Yes indeed.  I run with updated versions because I need the functionality and when I installed the with with git20121211, the bridge update bit me on virtual network devices for IPv4 but (strangely) not IPv6.
Comment 31 Chris Smart 2013-02-04 17:20:19 EST
(In reply to comment #29)
> 
> About to land in Fedora soon.

Hi Dan,

Any chance this can be backported to F18, or just F19 as per your feature:
https://fedoraproject.org/wiki/Features/NetworkManagerBridging

-c
Comment 32 Dean Hunter 2013-03-19 18:50:38 EDT
Oh NO! I was so looking forward to this. 

I see from https://fedoraproject.org/wiki/Features/NetworkManagerBridging 

 Current status

    Targeted release: Fedora 20
    Last updated: 2013-03-19
    Percentage of completion: 50% 

For those of us that would REALLY like to use bridging with libvirt/QEMU/KVM, is there a recommended work-around for use with Fedora 18?
Comment 33 Dan Williams 2013-03-20 10:57:18 EDT
The code is going to land, it's just not going to make the F19 feature freeze  deadline.  And because of this, we want to make sure it's rock-solid before that happens, since people don't have the heads-up that the feature process would normally give.
Comment 34 Dean Hunter 2013-03-20 11:55:44 EDT
That is good and I am willing to do whatever I can to help test it.

But what we really need to know NOW is the recommended work-around. I am willing to accept that the network management applet of the Gnome Control Center can not be used or displays erroneous or misleading information. But does the NetworkManager service work correctly? if so, what should the ifcfg-br1 and ifcfg-em1 files look like? Are there steps to be taken before configuring NetworkManager? What about routing?

These are some of the details we hope will become transparent and I am certain you know them better than we do. There is a lot of information available that seems dated in one regard or another and virsh iface-bridge, which seemed like a big step forward, returns an error (https://bugzilla.redhat.com/show_bug.cgi?id=919625).

It is my understanding that a bridge could be configured to make the virtual machine guests appear on the network as if they were network peers of the physical machine host; they would used the same DHCP as the physical machines, the same address range, the same DNS, etc. I have tried piecing together the configuration, but nothing I have done quite works.

Please, is there a document you could reference or instructions you could provide for of us that are not expert enough in the networking utilities to dig it out on our own?
Comment 35 johnny.westerlund 2013-03-21 06:51:29 EDT
If you need a simple work-around for simple bridging there is support for it in virt-manager by using a macvtap device.

To bridge a guest to your configured em1/eth0 just edit your virtual-machine in virt-manager

on the nic in virt-manager of the virtual machine there should be a drop drown list for: "Source device".
Just pick "Host device eth0 : macvtap"
Comment 36 Dean Hunter 2013-03-22 11:07:35 EDT
I have tried macvtap. While it works with NetworkManager I have two problems with this approach:

  1) It requires a second network for connectivity from the VM guest to the host.
  2) It requires manual use of a GUI to set it up.

I need something that I can script, start, and come back when it is ready to use. 

So far, http://docs.fedoraproject.org/en-US/Fedora/17/html/System_Administrators_Guide/s2-networkscripts-interfaces_network-bridge.html is the most recent reference I have found. It only works if NetworkManager is replace is replaced by network on the host, but this can be scripted. I am using this on a server class machine so wireless networking is not important.

What do I lose with this approach?
Comment 37 Fedora End Of Life 2013-12-21 09:50:15 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 38 Fedora End Of Life 2014-02-05 17:37:56 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.